#include "parms_vec.h"

#if defined(FORTRAN_CAPS)
#define parms_vecaxpy_                PARMS_VECAXPY            
#define parms_vecaypx_		      PARMS_VECAYPX            
#define parms_veccreate_	      PARMS_VECCREATE          
#define parms_vecdot_		      PARMS_VECDOT             
#define parms_vecdotarray_	      PARMS_VECDOTARRAY        
#define parms_vecfree_		      PARMS_VECFREE            
#define parms_vecgetglobalsize_	      PARMS_VECGETGLOBALSIZE   
#define parms_vecgetlocalsize_	      PARMS_VECGETLOCALSIZE    
#define parms_vecgetnorm2_	      PARMS_VECGETNORM2        
#define parms_vecput_		      PARMS_VECPUT             
#define parms_vecscale_		      PARMS_VECSCALE           
#define parms_vecsetvalues_	      PARMS_VECSETVALUES       
#define parms_vecsetup_		      PARMS_VECSETUP           
#define parms_vecview_                PARMS_VECVIEW
#define parms_vecattacharray_         PARMS_VECATTACHARRAY
#define parms_vecpermaux_             PARMS_VECPERMAUX
#define parms_vecinvpermaux_          PARMS_VECINVPERMAUX
#elif defined(FORTRAN_DOUBLE_UNDERSCORE)
#define parms_vecaxpy_                parms_vecaxpy__            
#define parms_vecaypx_		      parms_vecaypx__            
#define parms_veccreate_	      parms_veccreate__          
#define parms_vecdot_		      parms_vecdot__             
#define parms_vecdotarray_	      parms_vecdotarray__        
#define parms_vecfree_		      parms_vecfree__            
#define parms_vecgetglobalsize_	      parms_vecgetglobalsize__   
#define parms_vecgetlocalsize_	      parms_vecgetlocalsize__    
#define parms_vecgetnorm2_	      parms_vecgetnorm2__        
#define parms_vecput_		      parms_vecput__             
#define parms_vecscale_		      parms_vecscale__           
#define parms_vecsetvalues_	      parms_vecsetvalues__       
#define parms_vecsetup_		      parms_vecsetup__           
#define parms_vecview_                parms_vecview__
#define parms_vecattacharray_         parms_vecattacharray__
#define parms_vecpermaux_             parms_vecpermaux__
#define parms_vecinvpermaux_          parms_vecinvpermaux__
#elif !defined(FORTRAN_UNDERSCORE)
#define parms_vecaxpy_                parms_vecaxpy            
#define parms_vecaypx_		      parms_vecaypx            
#define parms_veccreate_	      parms_veccreate          
#define parms_vecdot_		      parms_vecdot             
#define parms_vecdotarray_	      parms_vecdotarray        
#define parms_vecfree_		      parms_vecfree            
#define parms_vecgetglobalsize_	      parms_vecgetglobalsize   
#define parms_vecgetlocalsize_	      parms_vecgetlocalsize    
#define parms_vecgetnorm2_	      parms_vecgetnorm2        
#define parms_vecput_		      parms_vecput             
#define parms_vecscale_		      parms_vecscale           
#define parms_vecsetvalues_	      parms_vecsetvalues       
#define parms_vecsetup_		      parms_vecsetup           
#define parms_vecview_                parms_vecview
#define parms_vecattacharray_         parms_vecattacharray
#define parms_vecpermaux_             parms_vecpermaux
#define parms_vecinvpermaux_          parms_vecinvpermaux
#endif

void parms_vecaxpy_(parms_Vec *self, parms_Vec *x, FLOAT *scalar, int
		    *ierr)
{
  *ierr = parms_VecAXPY(*self, *x, *scalar);
}

void parms_vecaypx_(parms_Vec *self, parms_Vec *x, FLOAT *scalar, int
		    *ierr)
{
  *ierr = parms_VecAYPX(*self, *x, *scalar);
}

void parms_veccreate_(parms_Vec *self, parms_Map *map, int *ierr)
{
  *ierr = parms_VecCreate(self, *map);
}

void parms_vecdot_(parms_Vec *self, parms_Vec *x, REAL *value, int
		   *ierr) 
{
  *ierr = parms_VecDOT(*self, *x,  value);
}

void parms_vecdotarray_(parms_Vec *self, int *n, parms_Vec *vecarray,
			FLOAT  *aux, FLOAT *result, int *ierr) 
{
  *ierr = parms_VecDotArray(*self, *n, vecarray, aux, result);   
}

void parms_vecfree_(parms_Vec *self, int *ierr)
{
  *ierr = parms_VecFree(self);
}

void parms_vecgetglobalsize_(parms_Vec *self, int *gsize)
{
  *gsize = parms_VecGetGlobalSize(*self);
}

void parms_vecgetlocalsize_(parms_Vec *self, int *lsize)
{
  *lsize = parms_VecGetLocalSize(*self);
}

void parms_vecgetnorm2_(parms_Vec *self, REAL *value, int *ierr)
{
  *ierr = parms_VecGetNorm2(*self, value);
}

void parms_vecput_(parms_Vec *self, FLOAT *value, int *ierr)
{
  *ierr = parms_VecPut(*self, *value);
}

void parms_vecscale_(parms_Vec *self, FLOAT *scalar, int *ierr)
{
  *ierr = parms_VecScale(*self, *scalar);
}

void parms_vecsetvalues_(parms_Vec *self, int *m, int *im, FLOAT
			 *values, INSERTMODE *mode, int *ierr)
{
  *ierr = parms_VecSetValues(*self, *m, im, values, *mode); 
}

void parms_vecsetup_(parms_Vec *self, int *ierr)
{
  *ierr = parms_VecSetup(*self);
}

void parms_vecview_(parms_Vec *self, parms_Viewer *v, int *ierr)
{
  *ierr = parms_VecView(*self, *v);
}

void parms_vecattacharray_(parms_Vec *self, FLOAT *array, int *ierr)
{
  *ierr = parms_VecAttachArray(*self, array);
}

void parms_vecpermaux_(parms_Vec *self, FLOAT *array, int *ierr)
{
  *ierr = parms_VecPermAux(*self, array);
}

void parms_vecinvpermaux_(parms_Vec *self, FLOAT *array, int *ierr)
{
  *ierr = parms_VecInvPermAux(*self, array);
}
